//MUPS - Jun 2008 - zadatak 9
//Kvadriranje niza

#include "mpi.h"
#include <iostream>
#include <cstdlib>
#include <ctime>
#include <cmath>

using namespace std;

#define N 5
enum proc {MASTER, SLAVE};

//funkcija koja kvadrira zadati niz
void square_array(int* array, int n) {
	for(int i=0;i<n;i++) 
		array[i]=array[i]*array[i];
}

int main (int argc, char* argv[]) {
	
	//inicijalizuj MPI svet
	MPI::Init(argc, argv);
	
	//dohvati rang iz globalnog komunikatora
	int rank = MPI::COMM_WORLD.Get_rank();
	//dohvati velicinu globalnog komunikatora
	int size = MPI::COMM_WORLD.Get_size();

	//ispisi poruke
	cout << "Hello MPI world!" << endl;	
	cout << "Moj rang je: " << rank << endl;
	cout << "Ukupan broj procesa u ovom komunikatoru je: " << size << endl;
	
	int n;
	int* send_buff;
	int* recv_buff;
	//ako si master - delis posao, ali i radis posao - za primer drugima
	if (rank==MASTER) {

		cout << "Unesite broj elemenata niza: ";
		cin >> n;
		
		long chunk_n = (n+(size - n%size))/size;
		send_buff = new int[n+(size - n%size)];
		recv_buff = new int[chunk_n];
		for(int i=0;i<n;i++) 
			send_buff[i]=0;
		
		cout << endl << "Unesite elemente niza: " << endl;
		for(int i=0;i<n;i++)
			cin >> send_buff[i];
		
		//posalji podatak o duzinu dela niza za obradu
		MPI::COMM_WORLD.Bcast(&chunk_n,1,MPI::INT,MASTER);
		
		//posalji po parce niza
		MPI::COMM_WORLD.Scatter(send_buff,chunk_n,MPI::INT,recv_buff,chunk_n,MPI::INT,MASTER);

		//obradi svoj deo posla
		square_array(recv_buff,chunk_n);

		//prikupi rezultate
		int* result_buff = new int[chunk_n*size];
		MPI::COMM_WORLD.Gather(recv_buff,chunk_n,MPI::INT,result_buff,chunk_n,MPI::INT,MASTER);

		cout << "Pocetni niz: " << endl;
		for(int i=0;i<n;i++)
			cout << send_buff[i] << " ";
		cout << endl;
		cout << "Kvadrirani niz: " << endl;
		for(int i=0;i<n;i++)
			cout << result_buff[i] << " ";
	
		delete [] send_buff;
		delete [] recv_buff;
		delete [] result_buff;
	}
	//ako si slave - radi sta ti daju
	else {
		//primi velicinu posla
		MPI::COMM_WORLD.Bcast(&n,1,MPI::LONG,MASTER);
		recv_buff = new int[n];
		//primi posao
		MPI::COMM_WORLD.Scatter(0,n,MPI::INT,recv_buff,n,MPI::INT,MASTER);
		//odradi ga
		square_array(recv_buff,n);
		//posalji rezultat natrag glavonji
		MPI::COMM_WORLD.Gather(recv_buff,n,MPI::INT,0,n,MPI::INT,MASTER);
		cout << "Obradio " << n << " elemenata niza. " << endl << "Zavrsavam..." << endl;
		delete [] recv_buff;
	}
	
	//zavrsi MPI svet
	MPI::Finalize();
	return 0;
}