//MUPS - SI K2 2008/09 - zadatak 6
//trazenje max i min i njihovih pozicija u nizu

#include "mpi.h"
#include <iostream>

using namespace std;

enum proc {MASTER, SLAVE};

int main (int argc, char* argv[]) {
	
	//inicijalizacija
	MPI::Init(argc,argv);

	//uzmi rang i velicinu komunikatora
	int rank = MPI::COMM_WORLD.Get_rank();
	int size = MPI::COMM_WORLD.Get_size();

	//ispisi poruke
	cout << "Hello MPI world!" << endl;	
	cout << "Moj rang je: " << rank << endl;
	cout << "Ukupan broj procesa u ovom komunikatoru je: " << size << endl;

	//master ucitava podatke, radi posao i ispisuje rezultate
	if (rank == MASTER) {
		int n;
		cout << "Unete duzinu niza: ";
		cin >> n;

		//slanje podatka o duzini niza
		MPI::COMM_WORLD.Bcast(&n,1,MPI::INT,MASTER);
		int chunk = n / size;

		//prekid ukoliko nije zadovoljen uslov
		if (n%size != 0) {
			cout << "Duzina niza nije celobrojni umnozak broja procesa!\nPREKIDAM!";
			MPI::COMM_WORLD.Abort(size);
		}
		
		//ucitavnaje niza
		double* send_buff = new double[n];
		cout << endl << "Unesite elemente niza: " << endl;
		for(int i=0;i<n;i++)
			cin >> send_buff[i];

		//slanje parceta niza svima, ukljucujuci i samog sebe
		double* recv_buff = new double[chunk];
		MPI::COMM_WORLD.Scatter(send_buff,chunk,MPI::DOUBLE,recv_buff,chunk,MPI::DOUBLE,MASTER);

		//trazimo lokalni max
		double max = recv_buff[0];
		int pos = 0;
		for(int i=1;i<chunk;i++)
			if (recv_buff[i] > max) {
				max = recv_buff[i];
				pos = i;
			}

		double* res_buff = new double[size];
		int* res_pos = new int[size];
		//sakupljanje maximuma i pozicije
		MPI::COMM_WORLD.Gather(&max,1,MPI::DOUBLE,res_buff,1,MPI::DOUBLE,MASTER);
		MPI::COMM_WORLD.Gather(&pos,1,MPI::INT,res_pos,1,MPI::INT,MASTER);
		
		//trazimo max od lokalnih
		max = res_buff[0];
		pos = 0;
		int max_pos = res_pos[0];
		for(int i=1;i<size;i++) {
			cout << "res = " << res_buff[i] << " ";		
			if (res_buff[i] > max) {
				max = res_buff[i];
				max_pos = res_pos[i];
				pos = i;
			}
		}

		cout << "Max = " << max << " na poziciji " << pos*chunk + max_pos << endl;

		delete [] send_buff;
		delete [] recv_buff;
		delete [] res_buff;
		delete [] res_pos;
	} 
	//slave radi posao
	else {
		int n;
		
		MPI::COMM_WORLD.Bcast(&n,1,MPI::INT,MASTER);

		if (n%size != 0) {
			cout << "Duzina niza nije celobrojni umnozak broja procesa!\nPREKIDAM!";
			MPI::COMM_WORLD.Abort(size);
		}
		
		//primanje niza za obradu
		int chunk = n/size;
		double* recv_buff = new double[chunk];
		MPI::COMM_WORLD.Scatter(0,chunk,MPI::DOUBLE,recv_buff,chunk,MPI::DOUBLE,MASTER);

		//trazimo max
		double max = recv_buff[0];
		int pos = 0;
		for(int i=1;i<chunk;i++)
			if (recv_buff[i] > max) {
				max = recv_buff[i];
				pos = i;
			}

		cout << max << "  " << pos;
		
		//slanje lokalnog maximuma i njegove pozicije
		MPI::COMM_WORLD.Gather(&max,1,MPI::DOUBLE,0,size,MPI::DOUBLE,MASTER);
		MPI::COMM_WORLD.Gather(&pos,1,MPI::INT,0,size,MPI::INT,MASTER);
		
		cout << "Obradio " << chunk << " elemenata niza. " << endl << "Zavrsavam..." << endl;
		delete [] recv_buff;
	}
	
	MPI::Finalize();
	return 0;
}