//------------------------------------------------------------------------------
/**
@file "MPI/C++/Primer 0 - hello/hello_mpi.cpp"
@brief Jednostavan primer MPI programa na jeziku C++.
*/
//------------------------------------------------------------------------------

#include <mpi.h>
#include <iostream>

//------------------------------------------------------------------------------

using namespace std;

//------------------------------------------------------------------------------

/**
@brief Glavni program
@param argc Broj argumenata komandne linije.
@param argv Argumenti komandne linije.
@return Vraca @b 0 ako je sve uspesno izvrseno.
*/
int main(int argc, char* argv[])
{
	int rank, size;
	
	// Inicijalizujemo MPI
	MPI::Init(argc, argv);
	
	// Trazimo svoj poredak unutar MPI sveta (prvi je 0)
	rank = MPI::COMM_WORLD.Get_rank();
	
	// Trazimo velicinu MPI sveta
	size = MPI::COMM_WORLD.Get_size();
	
	cout << "Zdravo svima! Ja sam broj " << rank
			<< " od ukupno " << size << endl;
	
	// Zavrsavamo MPI
	MPI::Finalize();
	
	return 0;
}

//------------------------------------------------------------------------------
