/******************************************************************************/
/**
@file "MPI/C/Primer 0 - hello/hello_mpi.c"
@brief Jednostavan "Hello World" MPI primer
*/
/******************************************************************************/

#include <mpi.h>
#include <stdio.h>

/******************************************************************************/

/**
@brief Glavni program
@param argc Broj argumenata komandne linije
@param argv Argumenti komandne linije
@return Vraca @b 0 ako je sve uspesno izvrseno

U glavnom programu ispisujemo pozdravnu poruku koja prikazuje velicinu
MPI sveta i rang nase masine u njemu
*/
int main(int argc, char *argv[]) {
	int rank, size;
	
	/* Inicijalizujemo MPI */
	MPI_Init(&argc, &argv);
	
	/* Trazimo svoj rang unutar MPI sveta (prvi je 0) */
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	
	/* Trazimo velicinu MPI sveta */
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	
	/* Ispisujemo poruku na standardnom izlazu */
	printf("Zdravo svima! Ja sam broj %d od ukupno %d\n", rank, size);
	
	/* Zavrsavamo MPI */
	MPI_Finalize();
	
	return 0;
}

/******************************************************************************/
