/******************************************************************************/
/**
@file "hello_openmp.cpp"
@brief Jednostavan "Hello World" OpenMP primer
*/
/******************************************************************************/
#include <iostream>
#include <omp.h>

#define NUM_THREADS 3

/******************************************************************************/

/**
@brief Glavni program
@param argc Broj argumenata komandne linije
@param argv Argumenti komandne linije

U glavnom programu ispisujemo pozdravnu poruku koja prikazuje broj niti.
*/
void main(int argc, char *argv[]){   
    
    #pragma omp parallel num_threads(NUM_THREADS)
    /*direktivu critical ovde koristimo jer je u suprotnom moguce da OS pristup konzoli 
    dodeli tako da niti ne uspeju da iz jednog puta ispisu citav pozdravni string. */
    #pragma omp critical 
    std::cout << "Zdravo! Ja sam nit br. " << omp_get_thread_num() << "!" << std::endl;

}
/******************************************************************************/