//------------------------------------------------------------------------------
/**
@file "Pthreads/C++/Primer 1 - thread/BoundedBufferCpp.cpp"
@brief Implementacija metoda klase deljenih bafera.
*/
//------------------------------------------------------------------------------

#include "BoundedBufferCpp.h"

//------------------------------------------------------------------------------

void BoundedBufferCpp::put(int itm)
{
	empty->wait();
	mutex->wait();

	a[i] = itm;
	i = (i + 1) % n;
	
	mutex->signal();
	full->signal();
}

//------------------------------------------------------------------------------

int BoundedBufferCpp::get()
{
	full->wait();
	mutex->wait();
	
	int r = a[j];
	j = (j + 1) % n;
	
	mutex->signal();
	empty->signal();
	
	return r;
}

//------------------------------------------------------------------------------

BoundedBufferCpp::BoundedBufferCpp(int s)
{
	n = s;
	a = new int [n];
	mutex = new SemaphoreCpp(1);
	full = new SemaphoreCpp(0);
	empty = new SemaphoreCpp(n);
	
	i = j = 0;
}

//------------------------------------------------------------------------------
