//------------------------------------------------------------------------------
/**
@file "Pthreads/C++/Primer 1 - thread/BoundedBufferCpp.h"
@brief Definicija klase deljenih bafera.
*/
//------------------------------------------------------------------------------

#ifndef _BoundedBufferCpp_h_
#define _BoundedBufferCpp_h_

//------------------------------------------------------------------------------

#include "SemaphoreCpp.h"

//------------------------------------------------------------------------------

/**
@brief Klase deljenih bafera.
*/
class BoundedBufferCpp
{
	public:
		/**
		@brief Konstruktor klase.
		@param size Duzina bafera.

		Alocira novi bafer duzine size i inicijalizuje semafore.
		*/
		BoundedBufferCpp(int size);

		/**
		@brief Dodaje novi element u bafer.
		@param itm Element koji je potrebno dodati u bafer.
		*/
		void put(int itm);

		/**
		@brief Uzima element iz bafera	.
		@return int Vraca dohvaceni element po vrednosti.
		*/		
		int get();

	protected:
		/**
		@property mutex
		@brief Semafor mutex.

		Vodi racuna o sinhronizaciji izmedju niti.
		*/
		/**
		@property full
		@brief Semafor full.

		Prati broj popunjenih mesta u baferu.
		*/
		/**
		@property empty
		@brief Semafor empty.

		Prati broj praznih mesta u baferu.
		*/
		/**
		@property n
		@brief Broj elemenata bafera.
		*/
		/**
		@property i
		@brief Brojac.
		*/
		/**
		@property j
		@brief Brojac.
		*/
		/**
		@property a
		@brief Niz celih brojeva - bafer.
		*/
		SemaphoreCpp* mutex, *full, *empty;
		int n, i, j, *a;
};

//------------------------------------------------------------------------------

#endif

//------------------------------------------------------------------------------
