//------------------------------------------------------------------------------
/**
@file "Pthreads/C++/Primer 1 - thread/NitX.h"
@brief Klasa korisnicke niti izvedena iz klase Thread.
*/
//------------------------------------------------------------------------------

#ifndef _NitX_h_
#define _NitX_h_

//------------------------------------------------------------------------------

#include <iostream>
#include "ThreadCpp.h"
#include "SemaphoreCpp.h"
#include "sleep.h"

//------------------------------------------------------------------------------

using namespace std;

//------------------------------------------------------------------------------

/**
@brief Klasa NitX.

Klasa korisnicke niti izvedena iz klase Thread.
*/
class NitX : public ThreadCpp
{
	public:
		/**
		@brief Konstruktor klase.
		@param s1 Prvi semafor.
		@param s2 Drugi semafor.
		@param x Pokazivac ka prvom deljenom podatku.
		@param y Pokazivac ka drugom deljenom podatku.
		@param z Pokazivac ka trecem deljenom podatku.

		Alocira i inicijalizuje novi objekat tipa NitX.
		*/
		NitX(SemaphoreCpp* s1, SemaphoreCpp* s2, int* x, int* y, int* z)
		{
			this->s1 = s1;
			this->s2 = s2;
			this->x = x;
			this->y = y;
			this->z = z;
		}
	
	protected:
		/**
		@brief Posao koji nit treba da odradi.

		U 10 ciklusa stvara po dva podatka i ispisuje ih na
		standardnom izlazu.
		*/
		virtual void run()
		{
			for (int i = 1; i <= 10; ++i) {
				*x = i; *y = i * i;
				cout << "Producer produced: " << *x << " " << *y << endl;
				s1->signal();
				s2->wait();
				cout << "Sum counted: " << *x << " + " << *y << " = " << *z << endl;
			}
			cout << "NitX finnished" << endl;
		}

		/**
		@property x
		@brief Pokazivac ka prvom deljenom podatku.
		*/
		/**
		@property y
		@brief Pokazivac ka drugom deljenom podatku.
		*/
		/**
		@property z
		@brief Pokazivac ka trecem deljenom podatku.
		*/
		int* x, *y, *z;
		/**
		@property s1
		@brief Prvi semafor.
		*/
		/**
		@property s2
		@brief Drugi semafor.
		*/
		SemaphoreCpp* s1, *s2;
};

//------------------------------------------------------------------------------

#endif

//------------------------------------------------------------------------------
